#include "ipc_msq.h"
#include "ipc_shm.h"
int MsqCreate(){
    int msg_id = msgget(MSQ_DEFAULT_KEY,IPC_CREAT|0644);
    return msg_id;
}


int MsqIsExist(){
    if(msgget(MSQ_DEFAULT_KEY,IPC_EXCL)>=0){
        return 1;
    } else {
        return 0;
    }
}

int MsqDrop(){
    struct msqid_ds *msg_queue_info;
    return msgctl(MsqCreate(), IPC_RMID, 0);
}

// return: (0: 성공), (-1:error)
int MsqSend(MsgContent *content){
    int msqid=MsqCreate();
    if(!MsqIsExist()){
        return -1;
    }
    return msgsnd(msqid,content,sizeof(MsgContent)+1,IPC_NOWAIT);
}