#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>
#include<string.h>
#include "../ipc_module/ipc_msq.h"
#include "../ipc_module/ipc_shm.h"

MsgContent MakeMsg(int type,int pid ,char *data, int status){
    MsgContent msg;
    msg.msgtype=type;
    msg.pid = pid;
    strcpy(msg.data,data);
    msg.status = status;
    return msg;
}
int main(int argc,char *argv[]) {
    pid_t forked_pid;
    int parent_pid,child_pid;
    parent_pid=getpid();
    forked_pid=fork();
    int msg_id=MsqCreate();
    if(forked_pid){
        //parents
        while(1){
            char text[260];
            MsgContent msg1;

            printf("[asdf]>");
            scanf("%s",text);
            if(strcmp(text,"exit")==0){
                msg1=MakeMsg(1,parent_pid,text,-1);
            } else {
                msg1=MakeMsg(1,parent_pid,text,1);
            }
            msgsnd(MsqCreate(),&msg1,sizeof(MsgContent)+1,IPC_NOWAIT);
            if(strcmp(text,"exit")==0){
                MsqDrop();
                break;
            }
        }
        printf("parents end\n");
    } else {
        //child

        while(1){
            MsgContent msg2;
            if(msgrcv(msg_id,&msg2,sizeof(MsgContent)+1,1,0)==-1) {
                printf("end\n");
                MsqDrop();
                break;
            }
            if(msg2.status==-1){
                printf("%d is leave.\n",parent_pid);
                break;
            } else{
                printf("%d's say: %s\n",parent_pid,msg2.data);
            }
        }
        printf("chiled end\n");
    }
}
