//
// Created by centos on 10/18/23.
//

#ifndef SIMPLE_CHATTING_CONTROL_IPC_MSQ_H
#define SIMPLE_CHATTING_CONTROL_IPC_MSQ_H

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#define MSQ_DEFAULT_KEY 555567
#define STATUS_ENTER 1
#define STATUS_CHAT 0
#define STATUS_EXIT -1

typedef struct{
    long msgtype;
    int status;
    char *sender[20];
    char *data[260];
} MsgContent;
int MsqCreate();
int MsqDrop();
int MsqIsExist();
int MsqSend(MsgContent *content);
#endif //SIMPLE_CHATTING_CONTROL_IPC_MSQ_H
