//
// Created by centos on 10/18/23.
//

#ifndef SIMPLE_CHATTING_CONTROL_IPC_SHM_H
#define SIMPLE_CHATTING_CONTROL_IPC_SHM_H
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <string.h>
#include <stdio.h>
#include "ipc_msq.h"
#define SHM_DEFAULT_KEY 555556

typedef struct {
    int p_id;
    char p_name[11];
} ProcessInfo;

typedef struct {
    int server_pid;
    int msq_id;
    int proc;
    ProcessInfo proc1;
    ProcessInfo proc2;
}ProcessDir;

ProcessInfo ProcessInfoFactory(int pid,char *proc_name);
int ShmIsExist();
int ShmInit(int server_pid);
int GetShmID();
int ShmDrop();
void PrintProcessStatus();
int InsertProcessStatus (int pid,char *proc_name);
int RemoveProcessStatus (int pid);
int SelectProcessPID (char *proc_name);
int SelectMsqId();
char* SelectOtherSender(char *sender);
#endif //SIMPLE_CHATTING_CONTROL_IPC_SHM_H
